<?php

require_once($root_path."inc/db.inc.php");

require_once($root_path."inc/user.inc.php");

require_once($root_path."inc/config.inc.php");

class Ref

{





	function getRefererNum($userId,$lvl)

	{

		//This one returns the number of referers a user has. 

		$db=&new db;

		

		$sql="SELECT user_id FROM #_users WHERE ref1='$userId' AND level='$lvl'";

		$result=$db->get_row_num("users",$sql);

		return $result;

		}

	

		

	function getReferers($userId,$fieldToGet,$lvl)

	{

		$db=&new db;

		$sql="SELECT $fieldToGet FROM #_users WHERE ref1='$userId' AND level='$lvl'";

		if ($db->get_row_num("users",$sql) < 1)

		{

			return false;

		} else {

			$result=$db->get_row($fieldToGet,"users",$sql);

			if (count($result)==1)

			{

				return $result[0];

			} else {

				return $result;

			}

		}

	}

		

		function getCredits($userId)

		{

			$db=&new db;

			$sql="SELECT credits FROM #_users WHERE user_id='$userId'";

			$result=$db->get_row("credits","users",$sql);

			if (! is_numeric($result[0]))

			{

				$result[0]=0;

			}

			return $result[0];

		}



		function giveRefCredit($email,$refId)

		{

			//This function takes a user's email as argument, and 

			//decides who the referer of the user was and gives both the

			//level 1 and 2 referers the credit.

			

			//Step 1: Check if the refered id supplied is valid:

			if (! Ref::isIdValid($refId))

			{

				return false;

			}

			

			//Step whatever: Check if only unique referers are allowed, and 

			//if this is a unique guy:

			

			if (config::is_set('rank_gifts_unique'))

			{

				$db=&new db;

				$ip=getenv("REMOTE_ADDR");

				$sql="SELECT signup_ip	FROM #_users WHERE ref1='$refId'";

				if ($db->get_row_num('users',$sql) > 0)

				{

					return true;

				}

			}		

			

			//Step 2: get all of the involved credit values:

			$credits_lvl1=config::get_value('lvl1_normal_credits');

			$credits_lvl2=config::get_value('lvl2_normal_credits');

			$credits_lvl1_jv=config::get_value('lvl1_jv_credits');

			$credits_lvl2_jv=config::get_value('lvl2_jv_credits');

			

			

			//Step 3: Get the level 2 referer:

			

			$refId2=User::getInfo($refId,'ref1');

			

			

			

			//Step 4: Determine if the lvl 1 referer is JV and give him the credit:

			

			if (User::getInfo($email,'level') > 1)

			{

				$credit=$credits_lvl1_jv;

			} else {

				$credit=$credits_lvl1;

			}

			User::addCredits($refId,$credit);

			

			//Step 5:Determine if the lvl 2 referer is JV and give him the credit:

			

			if (empty($refId2))

			{

				return true;

			}

			

			if (User::getInfo($refId2,'level') > 1)

			{

				$credit=$credits_lvl2_jv;

			} else {

				$credit=$credits_lvl2;

			}

			User::addCredits($refId2,$credit);

			

			return true;

			

		}

			

			

			

			

			

			



	

	

	function isIdValid($userId)

	{

			//This function checks if a userId supplied is really the ID of a JV or not.

			if (! is_numeric($userId))

			{

				return false;

			}

			

			$db=&new db;

			$sql="SELECT status FROM #_users WHERE user_id='$userId' AND level > '1'";

			if ($db->get_row_num('users',$sql) <1)

			{

				return false;

			} else {

				return true;

			}

	}

	

		

	function isFireSale()

	{

		$db=&new db;

		$today=date('Y-m-d');

		$sql="SELECT firesale_id FROM #_firesales WHERE firesale_date='$today'";

		if ($db->get_row_num('firesales',$sql) < 1)

		{

			return false;

		} else {

			return true;

		}

	}

	

	function getFireSaleStatus()

	{

		$db=&new db;

		$today=date('Y-m-d');

		$start=config::get_value('jv_start_date');

		$end=config::get_value('jv_end_date');

		if ($today >=$start && $today <=$end)

		{

			return "OPEN";

		} 

		if ($today < $start)

		{

			return "PENDING";

		}

		

		if ($today > $end)

		{

			return "CLOSED";

		}

	}

		

		

	

	function getPrice()

	{

		if ( ! Ref::isFireSale())

		{

			$db=&new db;

			$sql="SELECT price FROM #_products WHERE special='1' LIMIT 1";

			$price=$db->getRow('price','products',$sql);

			$price=number_format($price, 2, '.','');

			return $price;

		}

		$db=&new db;

		$today=date('Y-m-d');

		$sql="SELECT price FROM #_firesales WHERE firesale_date='$today' LIMIT 1";

		$price=$db->getRow('price','firesales',$sql);

		$price=number_format($price, 2, '.','');

		return $price;

	}

	

	function getPriceById($id)

	{

		if (! is_numeric($id))

		{

			return false;

		}

		$db=&new db;

		$sql="SELECT special FROM #_products WHERE productId='$id'";

		$special=$db->getRow('special','products',$sql);

		if ($special > 0)

		{

			$price=Ref::getPrice();

			return $price;

		}

		$sql="SELECT price FROM #_products WHERE productId='$id'";

		$price=$db->getRow('price','products',$sql);

		$price=number_format($price, 2, '.','');

		return $price;

	}

		

	function getGiftPos($userId)

	{

		$db=&new db;

		$limit=config::get_value('gifts_per_page');

		$sql="SELECT user_id FROM #_gifts ORDER BY rank ASC";

		$rows=$db->get_row('user_id','gifts',$sql);

		if (count($rows) < 1)

		{

			return 0;

		} 

		$pos=0;

		foreach ($rows as $k=>$v)

		{

			$pos=$pos+1;

			if ($v==$userId)

			{

				return $pos;

			}

		}

		return 0;

	}

	

	

	function getRefShare($price)

	{

		if (! config::is_set('allow_split_payments'))

		{

			return 0;

		}

		

		$share=config::get_value('split_percentage');

		$refShare=($share/100)*$price;

		$refShare=number_format($refShare, 2, '.','');

		return $refShare;

	}

	

	

	function getOwnerShare($price)

	{

		if (! config::is_set('allow_split_payments'))

		{

			return $price;

		}

		

		$ownerShare=$price- Ref::getRefShare($price);

		$ownerShare=number_format($ownerShare, 2, '.','');

		return $ownerShare;

	}

		

	function getProductId()

	{

		$db=&new db;

		$sql="SELECT productId FROM #_products WHERE special='1' LIMIT 1";

		$id=$db->getRow('productId','products',$sql);

		return $id;

	}

		

	function getProductInfo($id,$info)

	{

		$db=&new db;

		$sql="SELECT $info FROM #_products WHERE productId='$id' LIMIT 1";

		$ret=$db->getRow($info,'products',$sql);

		return $ret;

	}

	

	/*

	function getUniqueRefNum($userId)

	{

		$db=&new db;

		$sql="SELECT signup_ip FROM #_users WHERE ref1='$userId'";

		$row1=$db->get_row('signup_ip','users',$sql);

		$row2=$db->get_row('signup_ip','users',$sql);

		

		$count=count($row1);

		//echo "count is <b>$count</b><p>";

		/*

		if ($count < 2)

		{

			return $count;

		}

		

		foreach ($row1 as $k=>$v)

		{

			$set=0;

			

			foreach ($row2 as $k2=>$v2)

			

			if ($v2==$v && $set==1)

			{

				$x=$x+1;

				$count=$count-1;

				echo "echo $x#: $v is equal to $v2<p>";

			} elseif ($v2==$v)

			{

				echo "setting set to 1<p>";

				$set=1;

			}

		}

		return $count;



		$totalCount=count($row1);

		foreach ($row1 as $k=>$v) {

		$count=0;

		foreach ($row2 as $k2=>$v2) {

		if ($v2==$v) {

			$count=$count+1;

			if ($count > 1) {

				if (! isset($added[$v])) {

				$totalCount=$totalCount-1;

				$added[$v]=$v;

			}

		}

	}

}

}

return $totalCount;

}

*/





	function getUniqueRefNum($userId)

	{

		$db=&new db;

		global $table_prefix;

		$sql="select count(*) refCount from ".$table_prefix."users WHERE ref1='$userId' group by signup_ip";

		

		$result=mysql_query($sql);

		$rows=mysql_num_rows($result);

		return $rows;

		}	



		

		function getRank($userId)

		{

			

			if (User::getInfo($userId,'credits') <1)

			{ //set user's rank to the highest rank in the db, so his gift ranks lowest.

				return Ref::getHighestRank();

			}

	

			$db=&new db;

			if ($db->get_row_num('gifts',"SELECT rank FROM #_gifts WHERE user_id='$userId'") < 1)

			{

				return false;

			}

			

			

			$sql="SELECT user_id FROM #_users ORDER BY credits DESC";

			$rows=$db->get_row('user_id','users',$sql);

			

			if (count($rows) < 1)

			{

				return false;

			} 

			$pos=0;

			foreach ($rows as $k=>$v)

			{

				if ($db->get_row_num('gifts',"SELECT rank FROM #_gifts WHERE user_id='$v'") > 0)

				{

					$pos=$pos+1;

					if ($v==$userId)

					{

						

						return $pos;

					}

				}

				

			}

			return Ref::getHighestRank();

		}

		

		

		function isRankForced($id,$idType)

		{

			//This function checks if the admin set a forced rank for a gift

			//or not. $idType can either contain 'user' or 'gift'.

			

			$db=&new db;

			$sql="SELECT forcedRank FROM #_gifts WHERE ".$idType."_id='$id' LIMIT 1";

			$giftId=$db->getRow('forcedRank','gifts',$sql);

			$ret=($giftId==1) ? true : false;

			return $ret;

		}

		

		function getHighestRank()

		{

			$db=&new db;

			$sql="SELECT rank FROM #_gifts ORDER BY RANK DESC";

			$temp=$db->get_row('rank','gifts',$sql);

			$rank=$temp[0]+1;

			return $rank;

		}

}		

?>
